/*
 * Copyright (C) 1995,1996,1997 RealNetworks, Inc.
 * All rights reserved.
 *
 * http://www.real.com/devzone
 *
 * This program contains proprietary information of RealNetworks, Inc.,
 * and is licensed subject to restrictions on use and distribution.
 *
 * $Id: auth.cc,v 1.2 2002/08/04 15:25:33 paul Exp $
 *
 * This file contains the methods for the authentication manager.
 */

#include <ctype.h>
#include "pntypes.h"
#include "pncom.h"
#include "rmaauth.h"
#include "os.h"
#include "auth.h"
#include "main.h"

tr_auth_manager::tr_auth_manager (void)
{
}

tr_auth_manager::~tr_auth_manager (void)
{
}

PN_RESULT
tr_auth_manager::HandleAuthenticationRequest
(IRMAAuthenticationManagerResponse *response)
{
  char username[1024];
  char password[1024];

  reset_tty ();
  fputs ("Authorization needed for this content.\n"
	 "Username: ", stdout);

  if (fgets (username, 1024, stdin))
    {
      char *c = username + strlen (username) - 1;

      while (c >= username && isspace (*c))
	c--;

      if (c < username)
	{
	  init_tty ();
	  return PNR_FAIL;
	}

      *(c + 1) = '\0';
      fputs ("Password: ", stdout);

      if (fgets (password, 1024, stdin))
	{
	  c = password + strlen (password) -1;

	  while (c >= password && isspace (*c))
	    c--;

	  if (c < password)
	    {
	      init_tty ();
	      return PNR_FAIL;
	    }

	  *(c + 1) = '\0';
	  response->AuthenticationRequestDone (PNR_OK, username, password);
	  init_tty ();
	  return PNR_OK;
      }
    }

  return response->AuthenticationRequestDone (PNR_NOT_AUTHORIZED, NULL, NULL);
}

UINT32
tr_auth_manager::AddRef (void)
{
  return 1;
}

UINT32
tr_auth_manager::Release (void)
{
  return 1;
}

PN_RESULT
tr_auth_manager::QueryInterface (const IID &id, void **obj)
{
  if (IsEqualIID (id, IID_IRMAAuthenticationManager) ||
      IsEqualIID (id, IID_IUnknown))
    {
      *obj = this;
      return PNR_OK;
    }

  *obj = NULL;
  return PNR_NOINTERFACE;
}
