/*
 * Copyright (C) 1995,1996,1997 RealNetworks, Inc.
 * All rights reserved.
 *
 * http://www.real.com/devzone
 *
 * This program contains proprietary information of RealNetworks, Inc.,
 * and is licensed subject to restrictions on use and distribution.
 *
 * $Id: error.cc,v 1.2 2002/08/04 15:25:33 paul Exp $
 *
 * This file contains the methods for the error handler.
 */

#include "pntypes.h"
#include "pncom.h"
#include "rmaerror.h"
#include "rmapckts.h"
#include "os.h"
#include "error.h"
#include "main.h"

tr_error_handler::tr_error_handler (void)
{
}

tr_error_handler::~tr_error_handler (void)
{
}

PN_RESULT
tr_error_handler::ErrorOccurred (const UINT8 severity, const ULONG32 rma_code,
				 const ULONG32 user_code, const char *user_str,
				 const char *url)
{
  IRMAErrorMessages *messages;
  IRMABuffer *buffer = NULL;

  if (player->QueryInterface (IID_IRMAErrorMessages, (void **)&messages)
      == PNR_OK)
    {
      buffer = messages->GetErrorText (rma_code);
      messages->Release ();
    }

  fprintf (stderr, "%s\n", buffer ? (char *) buffer->GetBuffer ()
	   : "An unknown error has occurred.");

  if (buffer != NULL)
    buffer->Release ();

  error = rma_code;
  return PNR_OK;
}

UINT32
tr_error_handler::AddRef (void)
{
  return 1;
}

UINT32
tr_error_handler::Release (void)
{
  return 1;
}

PN_RESULT
tr_error_handler::QueryInterface (const IID &id, void **obj)
{
  if (IsEqualIID (id, IID_IRMAErrorSink) ||
      IsEqualIID (id, IID_IUnknown))
    {
      *obj = this;
      return PNR_OK;
    }

  *obj = NULL;
  return PNR_NOINTERFACE;
}
