/*
 * Copyright (C) 1995,1996,1997 RealNetworks, Inc.
 * All rights reserved.
 *
 * http://www.real.com/devzone
 *
 * This program contains proprietary information of RealNetworks, Inc.,
 * and is licensed subject to restrictions on use and distribution.
 *
 * $Id: events.h,v 1.2 2002/08/04 15:25:33 paul Exp $
 *
 * This file contains the object definition for the event handler.
 */

#ifndef _EVENTS_H_
#define _EVENTS_H_

#include "rmaclsnk.h"

class tr_event_handler: public IRMAClientAdviseSink
{
 public:
  tr_event_handler (void);
  ~tr_event_handler (void);
  PN_RESULT OnPosLength (UINT32 position, UINT32 new_length);
  PN_RESULT OnPresentationOpened (void);
  PN_RESULT OnPresentationClosed (void);
  PN_RESULT OnStatisticsChanged (void);
  PN_RESULT OnPreSeek (UINT32 old_time, UINT32 new_time);
  PN_RESULT OnPostSeek (UINT32 old_time, UINT32 new_time);
  PN_RESULT OnStop (void);
  PN_RESULT OnPause (UINT32 time);
  PN_RESULT OnBegin (UINT32 time);
  PN_RESULT OnBuffering (UINT32 flags, UINT16 percent);
  PN_RESULT OnContacting (const char *host_name);
  PN_RESULT QueryInterface (const IID &id, void **obj);
  UINT32 AddRef (void);
  UINT32 Release (void);
};

#endif
