/*
 * Copyright (C) 1995,1996,1997 RealNetworks, Inc.
 * All rights reserved.
 *
 * http://www.real.com/devzone
 *
 * This program contains proprietary information of RealNetworks, Inc.,
 * and is licensed subject to restrictions on use and distribution.
 *
 * $Id: map.h,v 1.2 2002/08/04 15:25:33 paul Exp $
 *
 * This file defines a map structure and includes prototypes of the functions
 * that operate on it.
 */

#ifndef _MAP_H_
#define _MAP_H_

typedef struct
{
  void **keys;
  void **values;
  int size;
  int alloc_size;
}
map_t;

#ifdef __cplusplus
extern "C"
{
#endif

  /* Initialize a map. */
  extern void init_map (map_t *map);

  /* Attempt to get a value from a map.  If it was found, store it in the
     location to which the value pointer points and return 1.  Otherwise,
     return 0. */
  extern int map_get (const map_t *map, void *key, void **value);

  /* Remove a value from a map. */
  extern void map_remove (map_t *map, void *key);

  /* Put a value in a map, resizing the map if necessary. */
  extern void map_put (map_t *map, void *key, void *value);

#ifdef __cplusplus
}
#endif

#endif
