/*
 * Copyright (C) 1995,1996,1997 Progressive Networks.
 * All rights reserved.
 *
 * This program contains proprietary 
 * information of Progressive Networks, Inc, and is licensed
 * subject to restrictions on use and distribution.
 *
 * $Id: site.h,v 1.2 2002/08/04 15:25:33 paul Exp $
 *
 * This file defines the site object.
 */

#ifndef _SITE_H_
#define _SITE_H_

class tr_site: public IRMASite
{
 private:
  IRMASiteUser *user;
  IRMAValues *values;    
  IRMASiteWatcher *watcher;
  PNxSize size;
  PNxPoint position;
 public:
  tr_site (void);
  ~tr_site (void);
  PN_RESULT QueryInterface (const IID &id, void **obj);
  UINT32 AddRef (void);
  UINT32 Release (void);
  PN_RESULT AttachUser (IRMASiteUser *new_user);
  PN_RESULT DetachUser (void);
  PN_RESULT GetUser (IRMASiteUser *&current_user);
  PN_RESULT CreateChild (IRMASite *&child);
  PN_RESULT DestroyChild (IRMASite *child);
  PN_RESULT AttachWatcher (IRMASiteWatcher *new_watcher);
  PN_RESULT DetachWatcher (void);
  PN_RESULT SetPosition (PNxPoint new_position);
  PN_RESULT GetPosition (PNxPoint &current_position);
  PN_RESULT SetSize (PNxSize new_size);
  PN_RESULT GetSize (PNxSize &current_size);
  PN_RESULT DamageRect (PNxRect rect);
  PN_RESULT DamageRegion (PNxRegion region);
  PN_RESULT ForceRedraw (void);
};

#endif
